/* -*- genom -*-
 *
 * Copyright (c) 2010 CNRS/LAAS
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
#ifndef ATTENTIONALSTRUCT_H
#define ATTENTIONALSTRUCT_H


#define NUM_BEHAVIORS 2

#define WORKSPACE_DIST 2.1
#define INTERACTION_DIST 1.6
#define PROXIMITY_DIST 0.7
#define NO_DIST -1

#define MAX_HAND_SPEED 10
#define MIN_HAND_SPEED 3

#define NO_ACTION_VELOCITY 2 
// Attentional Parameters
#define ATTENTIONAL_PERIOD 1 // 1 tic is 10 ms

#define Period_Pick_Max    10 
#define Period_Place_Max   10 
#define Period_Give_Max    10 
#define Period_Receive_Max 10 
#define Period_Avoid_Max   5
#define Period_Min 1

// Attentional Constants
#define K_pick_att 2
#define K_AVOID   0.2

#define KWD_give 1.2
#define K3_att   1.2
#define K4_att   1.2 



//typedef struct UNINA_INPUT {
//   // human distance
//   double human_distance, x_human_position, y_human_position;
//   double hand_distance, x_hand_position, y_hand_position, z_hand_position;
//   int human_orientation;
//
//   //Target object:
//   double object_distance, x_object_position, y_object_position, z_object_position;
//   
//  //Eventually the position of another object in the environment:
//   double object_2_distance, x_object_2_position, y_object_2_position, z_object_2_position;
//   
//} UNINA_INPUT;

#define UNINA_MAX_OBJ 3

typedef struct UNINA_POS {
int available;
double x, y, z;
} UNINA_POS;

typedef struct UNINA_INPUT {
   // human distance
    double minimal_human_robot_distance;
    int human_in_the_scene; // 1 if there is a human; 0 otherwise
   
    UNINA_POS robot_to_human;
    int humanLooking;
    
    UNINA_POS robot_to_humanHand; 
    UNINA_POS robot_to_gripper;
    
    UNINA_POS robot_to_obj[UNINA_MAX_OBJ];
    
} UNINA_INPUT;

typedef struct BEHAVIOR_STATUS {
    int active;
    int cicle;
    int period;
 
    GENMANIP_ATTENTIONAL_INPUT last_sense;

} BEHAVIOR_STATUS;


typedef enum ATTENTIONAL_MODE {
    ATTENTIONAL_REAL,
    ATTENTIONAL_SIMULATION
} ATTENTIONAL_MODE;


typedef struct ATTENTIONAL_PARAMS {
    ATTENTIONAL_MODE mode;
    GEN_STRING128 posterName;
} ATTENTIONAL_PARAMS;


//SDI_F->attentionStatus.
typedef struct ATTENTIONAL_STATUS {   
    //Behavior status
    BEHAVIOR_STATUS behavior[NUM_BEHAVIORS];
    int holding;
    int human_int_mode;
    GENMANIP_ATTENTIONAL_INPUT input;    
} ATTENTIONAL_STATUS;



#endif
