/**
 ** attentionalMainCodels.cc
 **
 ** Codels called by execution task attentionalMain
 **
 ** Author: 
 ** Date: 
 **
 **/

/*
> %%%%%% Input
> %%%%%% Human Info:
> double human_distance, x_human_position, y_human_position;
> double hand_distance, x_hand_position, y_hand_position, z_hand_position;
> int orientation;
> %%%%% Target object:
> double object_distance, x_object_position, y_object_position, z_object_position;
> %%%%% Eventually the position of another object in the environment:
> double object_2_distance, x_object_2_position, y_object_2_position,
> z_object_2_position;
>
> %%%%% Output
> %%%%% A value in range [0,1] where 0 corresponds to no movement at all
> and 1 to max speed
*/

#include <portLib.h>
#include <stdlib.h>

#include "server/attentionalHeader.h"

#include <math.h>

#include "attentionalFunctions.h"

/*------------------------------------------------------------------------
 *
 * MainInit  --  Initialization codel (fIDS, ...)
 *
 * Description: 
 * 
 * Returns:    OK or ERROR
 */

STATUS
MainInit(int *report)
{
  SDI_F->humanCostDist.minDistRobToHum = 0.0;
  SDI_F->humanCostDist.costDistRobToHum = 0.0;
  

  return OK;
}

/*------------------------------------------------------------------------
 *
 * MainEnd  --  Termination codel
 *
 * Description: 
 * 
 * Returns:    OK or ERROR
 */

STATUS
MainEnd(void)
{
  SDI_F->humanCostDist.minDistRobToHum = 0.0;
  SDI_F->humanCostDist.costDistRobToHum = 0.0;

  return OK;
}

/*------------------------------------------------------------------------
 *
 * MainPerm  --  1st codel of permanent activity (called BEFORE other activities)
 *
 * Description: 
 * 
 * Reports:      OK
 * 
 * Returns:    OK or ERROR
 */

STATUS
MainPerm(int *report)
{
  SDI_F->time++;
  return OK;
}

// Simulated Time
static int simulatedTime = 0;

static double t = 0.0;
static double min = 0.0;
static double max = 0.0;

static int inizialization = 1;

// cicles and periods
/*
static int ciclo_p = 1;
static int ciclo_r = 1;
static int ciclo_g = 1;
static int ciclo_a = 1;
static int ciclo_pl = 1;
static int ciclo_sa = 1;

static int p_pick = 2;
static int p_rec = 2;
static int p_give = 2;
static int p_avoid = 2;
static int p_place = 2;
static int p_search = 2;
*/
//prova
static UNINA_INPUT attentional_input_data;
static GENMANIP_ATTENTIONAL_INPUT m_input_data;
static double cost[NUM_BEHAVIORS];

/* ----------------------------------------------------------------------
 *
 * PROVA
 *
*/

double minimum (double x, double y)
{
  if (x<=y) return x;
  else return y;
}

double maximum (double x, double y)
{
  if (x>=y) return x;
  else return y;
}

double cumulative_cost (double *v, int dim, int control) 
{  
 double min = NO_ACTION_VELOCITY;
 switch (control){
 case 0: 
   for(int i=0; i < NUM_BEHAVIORS; i++){
     if ((v[i]<=1) && (v[i]>=-1) && SDI_F->attentionalStatus.behavior[i].active)
       if (v[i] < min) min = v[i];
   }
   break;
 /*case 1:
   int count;
   for(int i=1; i < dim ; i++){
     if ((v[i]<=1) && (v[i]>=-1) && SDI_F->attentionalStatus.behavior[i].active){
       min += v[i];
       count++;
     }
   }
   if(count>0) min= min/count;
   break;*/
 }
 if (min == NO_ACTION_VELOCITY) return 1;
 else {printf("cost %f \n", min); 
  return min;}
}

/******* Simulated Read *****************************************************************
*
*
*
*****************************************************************************************/

int attentionalGENMANIP_ATTENTIONAL_INPUTPSimRead(GENMANIP_ATTENTIONAL_INPUT * input, int max_time)
{

 if (simulatedTime < max_time) {
  input->minimal_human_robot_distance = 10;
  input->human_in_the_scene = 0; // 1 if there is a human; 0 otherwise

   //UNINA_POS robot_to_human;
   input->robot_to_human.x = 10;
   input->robot_to_human.y = 0;
   input->robot_to_human.z = 0;
   input->robot_to_human.available = 1;

   //int humanLooking;
   input->humanLooking = 1;

   //UNINA_POS robot_to_humanHand;
   input->robot_to_humanHand.x = 10;
   input->robot_to_humanHand.y = 0;
   input->robot_to_humanHand.z = 0;
   input->robot_to_humanHand.available = 0;

   //UNINA_POS robot_to_gripper;
   input->robot_to_gripper.x = 0;
   input->robot_to_gripper.y = 0;
   input->robot_to_gripper.z = 0;
   input->robot_to_gripper.available = 1;

   //UNINA_POS robot_to_obj[UNINA_MAX_OBJ];
   if ( (10 - (simulatedTime)*0.2) > 0.0)
   {
    input->robot_to_obj[0].x = (5 - simulatedTime * 0.1);
    printf("distance update %f \n", input->robot_to_obj[0].x );
   }
   else input->robot_to_obj[0].x = 0;

   input->robot_to_obj[0].y  = 0;
   input->robot_to_obj[0].z = 0.5;
   input->robot_to_obj[0].available = 1;

   //UNINA_POS robot_to_gripper;
   input->robot_to_gripper.x = 0;
   input->robot_to_gripper.y = 0;
   input->robot_to_gripper.z = 0;
   input->robot_to_gripper.available = 1;

   simulatedTime++;

 //   printf("tempo %d\n", simulatedTime);

   return 1;
   }
   else
   {
     simulatedTime = 0;
     return -1; // scaduto il tempo di simulazione
   }
}

int attentionalPrint(GENMANIP_ATTENTIONAL_INPUT * input)
{
/*
 if (simulatedTime < max_time) {
  input->minimal_human_robot_distance = 10;
  input->human_in_the_scene = 0; // 1 if there is a human; 0 otherwise

   //UNINA_POS robot_to_human;
   input->robot_to_human.x = 10;
   input->robot_to_human.y = 0;
   input->robot_to_human.z = 0;
   input->robot_to_human.available = 1;

   //int humanLooking;
   input->humanLooking = 1;

   //UNINA_POS robot_to_humanHand;
   input->robot_to_humanHand.x = 10;
   input->robot_to_humanHand.y = 0;
   input->robot_to_humanHand.z = 0;
   input->robot_to_humanHand.available = 0;

   //UNINA_POS robot_to_gripper;
   input->robot_to_gripper.x = 10;
   input->robot_to_gripper.y = 0;
   input->robot_to_gripper.z = 0;

   //UNINA_POS robot_to_obj[UNINA_MAX_OBJ];
   if ( (10 - (simulatedTime)*0.2) > 0.0)
   {
    input->robot_to_obj[0].x = (10 - simulatedTime * 0.01);
  //  printf("distance update %f \n", input->robot_to_obj[0].x );
   }
   else input->robot_to_obj[0].x = 0;
*/
  printf(" --------------------------------- \n");
  printf(" input->robot_to_obj[0].x  = %f\n",input->robot_to_obj[0].x);
  printf(" input->robot_to_obj[0].y  = %f\n",input->robot_to_obj[0].y);
  printf(" input->robot_to_obj[0].z  = %f\n",input->robot_to_obj[0].z);


/*   //UNINA_POS robot_to_gripper;
   input->robot_to_gripper.x = 10;
   input->robot_to_gripper.y = 0;
   input->robot_to_gripper.z = 0;
   input->robot_to_gripper.available = 1;

   simulatedTime++;

 //   printf("tempo %d\n", simulatedTime);

   return 1;
   }
   else
   {
     simulatedTime = 0;
     return -1; // scaduto il tempo di simulazione
   }
*/
}

int 
attentionalUpdateCost(int behavior, GENMANIP_ATTENTIONAL_INPUT *input, double * vel, int *report)
{
  GENMANIP_ATTENTIONAL_INPUT last_sense, now_sense;
  int period_old, cicle_old, period_new=1, cicle_new, period_max;
  double temp_period;
  // Mem Data
  last_sense = SDI_F->attentionalStatus.behavior[behavior].last_sense;
  period_old = SDI_F->attentionalStatus.behavior[behavior].period;
  cicle_old  = SDI_F->attentionalStatus.behavior[behavior].cicle;
        
  // Sense Data
//  now_sense = *input;

  // Data Elaboration
  double human_distance, human_distance_old, obj_distance; 
  double human_relative_speed, human_speed = 0, r_human_speed, t_human_speed, hand_pos, hand_speed, att_object_speed; 
  int human_orient, attentional_break = 0, a_obj_distance = 0;
  
  
  human_distance_old = sqrt(pow(last_sense.robot_to_human.x,2)+pow(last_sense.robot_to_human.y,2));
  
  if (input->human_in_the_scene){
     human_relative_speed = (input->minimal_human_robot_distance - last_sense.minimal_human_robot_distance) / period_old;
     human_distance = sqrt(pow(input->robot_to_human.x,2)+pow(input->robot_to_human.y,2));
     human_speed = (human_distance - human_distance_old) / period_old;
  }
  if((input->robot_to_obj[0].available)&&(input->robot_to_gripper.available)){
     obj_distance = sqrt(pow((input->robot_to_obj[0].x - input->robot_to_gripper.x),2) + pow((input->robot_to_obj[0].y - input->robot_to_gripper.y),2));  
     a_obj_distance = 1;
  }
  else a_obj_distance = 0;
//  r_human_speed = (input->x_human_position - last_sense.x_human_position) / period_old ; 
//  t_human_speed = (input->y_human_position - last_sense.y_human_position) / period_old ;
//  hand_speed = (input-> hand_distance - last_sense.hand_distance) / period_old ;
//  human_orient = input->human_orientation ;
//  att_object_speed = 1; //(object_pos - object_old_pos)/period_old;
//  
//  int period_pick_max = 10, period_place_max = 10, period_give_max = 10, period_receive_max = 10, period_avoid_max = 5;
//  int period_space_obj;
//
//  // behavior selection
  if(inizialization!=1){
  switch ( behavior ) {
     case 0 : // avoid
        if ((input->human_in_the_scene) && (human_distance < WORKSPACE_DIST)){  
//           temp_period =
             period_new = 1; 
//           period_new = 1; //K_AVOID * (1/att_object_speed) * period_old; // inv. prop. alla velocita' di avvicinamento	
        }
        else
        {
	   period_new = period_old++; // relax linerly 
           period_new = maximum(minimum(period_new, Period_Avoid_Max),Period_Min);
        }

        // cost if released
        if ((input->human_in_the_scene) && (human_distance < WORKSPACE_DIST)){
           SDI_F->attentionalStatus.behavior[behavior].active=0;
           vel[behavior] = period_new / Period_Avoid_Max;
           if (human_distance < PROXIMITY_DIST){  //Safety critical condition -> stop motion
             attentional_break = 1;
             vel[behavior] = 0;
           }
        }
        else
          SDI_F->attentionalStatus.behavior[behavior].active=0;
          //Velocity has not to be considered in the output;
	break;	
//
     case 1 :  // pick	
          printf("update pick with distance %f ", obj_distance);
  //      period_max = Period_Pick_Max; 
        if ((a_obj_distance) && (obj_distance < INTERACTION_DIST) && (obj_distance>0)){
        // object distance w.r.t hand effector
          temp_period = Period_Pick_Max * pow(K_pick_att, 4*(obj_distance - 0.80 /*INTERACTION_DIST*/));
          printf("distance x %f ", input->robot_to_obj[0].x);
          printf("pick periodo double %f ", temp_period);
          period_new = (int)temp_period;
          printf("pick periodo int %d\n", period_new);
          period_new = minimum( maximum(period_new, Period_Min), Period_Pick_Max);
        }
        else
          period_new = Period_Pick_Max;

        // set vel cost if releasing
        if ((obj_distance < INTERACTION_DIST)&& (obj_distance>0)){
          SDI_F->attentionalStatus.behavior[behavior].active=1;
          vel[behavior] = (double)period_new / (double)Period_Pick_Max;
          printf("velocity %f \n", vel[behavior]);
        }
       else {
          SDI_F->attentionalStatus.behavior[behavior].active=0;
          //Velocity has not to be considered in the output;
       }
     break;	
//     case 2 : // receive
//
//
//        // If Op holds an object and not robot not holdse
//        if ( 1 /*input->operator_holding_object && !parms->holding*/) 
//        {
//           if ( input->human_distance > WORKSPACE_DIST ) 
//           {
//              // Human radial speed; 
//              if ( last_sense.x_human_position != NO_DIST ) 
//              {
//                 if ( r_human_speed > 0 )
//                 {
//                     period_new = 1; //period_avoid_max * KWD_give / (r_human_speed + 1) ; 
//                 }   
//                 else period_new = period_old++ ; // relaxing    
//              } 
//              else period_new = period_old; // stationary
//
//           } // Interaction
//           else if ( input->human_distance > INTERACTION_DIST ) 
//                {  
//                   //int period_space = period_give_max * pow(K3_att,(input->human_distance - WORKSPACE_DIST));
//                   //int period_speed = period_old * KWD_give / (human_speed + 1);
//                   
//                   // Human Speed, position, orientation
//                   if ( last_sense.x_human_position != NO_DIST ) 
//                   {
//                     if ( r_human_speed > 0 ) 
//                     {
//                         period_new = 1; //minimum(period_space, period_speed) ;     // contract
//                      } 
//                     else period_new = 1; //maximum(period_space, period_speed) ; // relax
//                   } 
//                   else  period_new = 1; // period_space; // only space
//                }  
//                else 
//                {
//                   int period_space = 1; //period_give_max * pow(K4_att,(input->human_distance - INTERACTION_DIST));
//                   int period_hand  = 1; // period_old * KWD_give / (hand_speed + 1);
//                   int period_speed = 1; // period_old * KWD_give / (human_speed + 1);
//
//                   // Proximity: Human orientation, position, speed 
//                   if ( input->human_orientation ) // DANGER: human not attending
//                   {
//                     period_new = 1;
//                     attentional_break = 1;
//                     vel[behavior] = 0;
//                   }
//                   else // Human attending
//                   {  
//                      if ( last_sense.hand_distance != NO_DIST ) 
//                        if( hand_speed > MAX_HAND_SPEED ) 
//                        { // hand_speed: too fast!
//                          period_new = 1;
//                          attentional_break = 1;
//                          vel[behavior] = 0;
//                        }
//                        else
//                        {
//                          if( hand_speed < MIN_HAND_SPEED ) 
//                            period_new = period_old++;
//                          else 
//                          {
//                             // hand moviment + proximity + human moviment
//                             period_new = 1; //minimum ( minimum ( period_space , period_hand ) , period_speed );
//                          } 
//                        }
//                      else
//                      {    // no previous hand position, only space
//                           period_new = 1; // period_space;
//                      }
//                   }
//                }
//
//        } 
//        else 
//        {   //DANGER: Too close, care!
//            period_new = 1;
//            attentional_break = 1;
//            vel[behavior] = 0;
//        }
//	
//        //vel[behavior] = 1;
//	break;
//
//     case 3 : // give
//        // analogous to give
//        vel[behavior] = 1;
//	break;
//
//     case 4 : // place
//
//        period_max = period_place_max; 
//        if (input->object_distance  < INTERACTION_DIST)
//          // object distance w.r.t hand effector
//          period_new = period_place_max * pow(K_pick_att, input->object_distance - INTERACTION_DIST);
//        else
//            period_new = period_old;
//
//        if ( ! attentional_break )
//          vel[behavior] = period_new / period_max ;
//       else 
//         vel[behavior] = 0;
//	
// 	break;
//
//
//     case 5 : // search
//        //only perceptive - not considered
//
//	vel[behavior] = 1;
//	break;
//     
     default: // Error: stop
     return  0;    
  }
 }
 else inizialization = 0;
//
//  // update cicle and period
//  
//  // range period
  SDI_F->attentionalStatus.behavior[behavior].period = period_new ;
//   
// 
  return 0; 
}

// releasing function 
int releasing(double * cost, int dim)
{

  return 0;
}

static POSTER_ID sparkPoster = NULL;

/*------------------------------------------------------------------------
 * CostControl
 *
 * Description: 
 *
 * Reports:      OK
 *              S_attentional_DELTAT_NEGATIVE
 *              S_attentional_MIN_GT_MAX
 */

/* attentionalCostControlStart  -  codel START of CostControl
   Returns:  START EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
attentionalCostControlStart(ATTENTIONAL_PARAMS *params, int *report)
{
  // The oder is the one of behavior calls
  int period_max[5] = {Period_Avoid_Max, Period_Pick_Max, Period_Receive_Max, Period_Place_Max, Period_Give_Max} ; 
    //initalize attentional status
  for (int i=0; i < NUM_BEHAVIORS ; i++ )
  {
     SDI_F->attentionalStatus.behavior[i].period = period_max[i];
     SDI_F->attentionalStatus.behavior[i].cicle = period_max[i];
     SDI_F->attentionalStatus.behavior[i].active = 0;
     // Not necessary: by default available = 0 
     //SDI_F->attentionalStatus.behavior[i].last_sense = 
     SDI_F->attentionalStatus.holding = 0;
     SDI_F->attentionalStatus.human_int_mode = 0;

//printf("num %d cicle %d period %d\n", NUM_BEHAVIORS, SDI_F->attentionalStatus.behavior[i].cicle, SDI_F->attentionalStatus.behavior[i].period);
  }



  if(params->mode == ATTENTIONAL_REAL) {
    printf("INFO attentionalCostControl Real Mode\n");    
    /* Find the external poster and try it by reading once */
    if( attentionalGENMANIP_ATTENTIONAL_INPUTPosterFind(params->posterName.name, &sparkPoster) == ERROR) {
      *report =  S_attentional_CANNOT_FIND_POSTER;
      return END;
    }
    else if(attentionalGENMANIP_ATTENTIONAL_INPUTPosterRead(sparkPoster,
							    &(SDI_F->attentionalStatus.input)) == ERROR) {
      *report =  S_attentional_CANNOT_READ_POSTER;
      return END;
    }
    else {
      printf("INFO attentionalCostControlStart OK\n");
      return EXEC;   
    }
  } else if(params->mode == ATTENTIONAL_SIMULATION) {
    printf("INFO attentionalCostControl Simulation Mode\n");    
    return EXEC; 
  } else {
    printf("ERROR attentionalCostControl Wrong Mode\n");
    return END;
  }

}

/* attentionalCostControlMain  -  codel EXEC of CostControl
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
attentionalCostControlMain(ATTENTIONAL_PARAMS *params, int *report)
{

  //questo è l'equivalente del nosrto controllo sul tempo fatto per un solo behavior
  //qui andrebbero fatte invece ogni ciclo le chiamate ai behavior

  if(params->mode == ATTENTIONAL_REAL) {
    if(attentionalGENMANIP_ATTENTIONAL_INPUTPosterRead(sparkPoster,
						       &(SDI_F->attentionalStatus.input)) == ERROR) {
      *report =  S_attentional_CANNOT_READ_POSTER;
      return END;
    }
  } else {
    // ADD YOUR FUNCTION TO FILL SDI_F->attentionalStatus.input HERE
    // It simulates a trajectory in 100 time units
   if(attentionalGENMANIP_ATTENTIONAL_INPUTPSimRead(&(SDI_F->attentionalStatus.input),1000)== -1) 
   {
     *report =  S_attentional_CANNOT_READ_POSTER;
   }
  }

  m_input_data = SDI_F->attentionalStatus.input;

  attentionalPrint(&m_input_data);
  
  //ALL BEHAVIOR
  for (int i=0; i < NUM_BEHAVIORS ; i++ )
    { //clock vs. period 
//printf("cicle %d period %d\n", SDI_F->attentionalStatus.behavior[i].cicle, SDI_F->attentionalStatus.behavior[i].period);
    if ((SDI_F->attentionalStatus.behavior[i].cicle) == (SDI_F->attentionalStatus.behavior[i].period))
      {
        //printf("update cost");
        //velocity and period update
    	attentionalUpdateCost(i,&m_input_data,cost,report);
        
        //cicle erased
	SDI_F->attentionalStatus.behavior[i].cicle = 1;
        
        // last sense update
        SDI_F->attentionalStatus.behavior[i].last_sense = m_input_data;
      }

      else
	{ //cicle updated
	  SDI_F->attentionalStatus.behavior[i].cicle++;
          printf("::");
	}
    } 


   // Releasing UPDATE
//   releasing(vel,NUM_BEHAVIORS);   

    //SPEED UPDATE
    double cost_tot = cumulative_cost(cost, NUM_BEHAVIORS, 0);
    SDI_F->humanCostDist.costDistRobToHum = 1.0 - cost_tot;
    printf("costout %f\n", cost_tot);
    return EXEC;
}
 
/* attentionalCostControlEnd  -  codel END of CostControl
   Returns:  END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
attentionalCostControlEnd(ATTENTIONAL_PARAMS *params, int *report)
{
  SDI_F->humanCostDist.costDistRobToHum = 1.0;
  return ETHER;
}




